﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;
using System.ServiceModel;
using SharedDataContract;

namespace ChatApplication
{
    public class clsSession : IDisposable
    {
        #region Initialize
        public  clsSession(OperationContext context, Person person)
        {
            mContext = context;
            currentPerson = person;
            currentpersonInfo = new PersonInfo();
            currentpersonInfo.SessionID = context.Channel.SessionId;
            currentpersonInfo.CurrentPerson = person;
            SetCallback();
        }

        private void SetCallback()
        {
            ICommunicationObject obj = (ICommunicationObject)mContext.GetCallbackChannel<IChatCallback>();
            obj.Closing += new EventHandler(obj_Closing);
            obj.Closed += new EventHandler(obj_Closing);
            obj.Faulted += new EventHandler(obj_Closing);
            mcallback = OperationContext.Current.GetCallbackChannel<IChatCallback>();
        }

       
        private Person currentPerson;
        private PersonInfo currentpersonInfo;
        private IChatCallback mcallback;

        public Person CurrentPerson
        {
            get { return currentPerson; }
            set { currentPerson = value; }
        }

        public PersonInfo CurrentPersonInfo
        {
            get { return currentpersonInfo; }
            set { currentpersonInfo = value; }
        }

        public IChatCallback ChatCallBack
        {
            get { return mcallback; }
            set { mcallback = value; }
        }

        private OperationContext mContext;

        public  string SessionID { get {return mContext.SessionId; } }
        #endregion

        #region ClientMethod
        public void UserEnter(Person personadd, AsyncCallback callback, object state)
        {
            ThreadedCallBack threadUserEnterCall = new ThreadedCallBack(mcallback);
            threadUserEnterCall.UserEnter(personadd, callback, state);

        }

        public void UserLeave(Person personremove, AsyncCallback callback, object state)
        {
            ThreadedCallBack threaduserLeave = new ThreadedCallBack(mcallback);
            threaduserLeave.UserLeave(personremove, callback, state);

        }

        public void UserActive(Person personactive, AsyncCallback callback, object state)
        {
            ThreadedCallBack threaduseractive = new ThreadedCallBack(mcallback);
            threaduseractive.UserActive(personactive, callback, state);

        }


        public void UserDeActive(Person persodeactive, AsyncCallback callback, object state)
        {
            ThreadedCallBack threaduserdeactive = new ThreadedCallBack(mcallback);
            threaduserdeactive.userDeActive(persodeactive, callback, state);
        }

        public void UserTimeOut(Person person, AsyncCallback callback, object state)
        {
            ThreadedCallBack threadusertimeout = new ThreadedCallBack(mcallback);
            threadusertimeout.UserTimeOut(person, callback, state);
        }

        public void UserAddUserList(Person person, AsyncCallback callback, object state)
        {
            ThreadedCallBack threaduseradduser = new ThreadedCallBack(mcallback);
            threaduseradduser.UserAddUserList(person, callback, state);
        }

        public void UserWhisper(Person person, string message, AsyncCallback callback, object state)
        {
            ThreadedCallBack threaduserwhisper = new ThreadedCallBack(mcallback);
            threaduserwhisper.userWhisper(person,message, callback, state);
        }

        public void UserVideo(Person person, VideoFrame video, AsyncCallback callback, object state)
        {
            ThreadedCallBack threaduservideo = new ThreadedCallBack(mcallback);
            threaduservideo.UserVideo(person, video, callback, state);
        }
        #endregion

        #region Dispose

        private bool mIsDipsosing;
        private bool mSessionTimedOut;
        private bool mTreeLocked;
        private bool mBoardLocked;
        private bool disposedValue;

        public  bool IsDisposing { get { return mIsDipsosing; } }
        public  bool Timedout { get { return mSessionTimedOut; } }
        public bool TreeLocked { get { return mTreeLocked; } set { mTreeLocked = value; } }
        public bool BoardLocked { get { return mBoardLocked; } set { mBoardLocked = value; } }

        public delegate void DisposedDelegate(string SessionID);
        public event DisposedDelegate Disposed;

        public  void  Dispose(bool disposing)
        {
            if (mIsDipsosing) return;
            mIsDipsosing = true;

            if (!disposedValue)
            {
                if (disposing)
                { 
                       //free other state (managed objects).
                
                }
            }

             //add your cleanup code here if you wish
            if (Disposed != null)
            {
                Disposed(SessionID);
            }
            disposedValue = true;

        }


        public void Dispose()
        {
            Dispose(true);
            GC.SuppressFinalize(this);

        }

        void obj_Closing(object sender, EventArgs e)
        {
            this.Dispose();
        }


        #endregion


    }
}
